<template>
  <table class="table">
    <thead>
      <tr>
        <th>Email</th>
        <th>Name</th>
        <th>Operations</th>
      </tr>
    </thead>
    <tbody>
      <tr v-for="user in users" v-bind:data-id="user.id">
        <td>{{ user.email }}</td>
        <td>
          <a v-bind:href="'/users/' + user.id">{{ user.name }}</a>
        </td>
        <td>
          <a
            class="badge badge-secondary badge-pill"
            v-bind:href="'users/' + user.id + '/edit/'"
          >Edit</a>
          <button class="btn btn-light" v-on:click="deleteEntry">Delete</button>
        </td>
      </tr>
    </tbody>
  </table>
</template>

<script>
const { default: Axios } = require("axios");

export default {
  data() {
    return {
      users: null
    };
  },
  mounted() {
    Axios.get("api/users").then(response => (this.users = response.data));
  },
  methods: {
    deleteEntry: function(event) {
      event.preventDefault();
      event.stopPropagation();
      console.log("delete event");
      Axios.delete(
        "api/users/" +
          $(event.target)
            .closest("tr")
            .data("id")
      ).then(
        $(event.target)
          .closest("tr")
          .remove()
      );
      console.log("user deleted");
    }
  }
};
</script>